/*
	"  *************************************************\n"\
	"  *          Generation d'Arbre Arbore            *\n"\
	"  *       fait par Jean-Charles BONTEMPS          *\n"\
	"  *                Licence GPL                    *\n"\
	"  *   http://poulphunter1.free.fr/ArbreArbore     *\n"\
	"  *           poulphunter@yahoo.fr                *\n"\
	"  *************************************************\n\n"\
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "read_write.h"
#include "arbredico.h"




freq_buffer* Freq_Calc(text_buffer* txt)
{	
	if (txt->size==0 || txt->buffer==0)
		return 0;
	freq_buffer *freq=malloc(sizeof(freq_buffer));
	freq->count=0;
	Arbre_Dico *tree=Arbre_Dico_Init();
	Arbre_Dico *t;
	int i,j;
	j=0;
	for (i=0;i<txt->size;i++)
	{
		if (i>j)
		{
			if (txt->buffer[i]==0)
			{
				t=Arbre_Dico_ADD(tree,&txt->buffer[j]);
				if (t->end==1)
				{
					if (t->number!=-1)
					{
						freq->freq[t->number]+=1;
					} else 
					{
						freq->buffer[freq->count]=&txt->buffer[j];
						freq->freq[freq->count]=1;
						t->number=freq->count;
						freq->count+=1;
					}
				}
				j=i+1;
			}
		} else {
			if (txt->buffer[i]==0)
				j=i+1;
			else
				j=i;
		}
	}
	Arbre_Dico_FREE(tree);
	return freq;
}

int Freq_Number(freq_buffer* freq,int nb,int max)
{
	int fq=0;
	int count=0;
	int i;
	while (1)
	{
		count=0;
		for (i=0;i<freq->count;i++)
		{
			if (freq->freq[i]>=fq)
				count+=1;
		}
		if (count==nb)
			return fq;
		if (count<nb)
		{
			if (max==0)
			{
				return fq-1;
			} else {
				return fq;
			}
		}
		fq+=1;
	}
	return fq;
}


text_buffer* Open_File(char *filename){
	text_buffer *txt=malloc(sizeof(text_buffer));
	FILE *pFile;
	int *lSize=malloc(sizeof(int));
	pFile=fopen(filename,"rb");
	if (pFile==0)
		return 0;
	fseek(pFile,0,SEEK_END);
	*lSize=ftell(pFile);
	rewind(pFile);
	txt->buffer=(char*)malloc(sizeof(char)*(*lSize)+2);
	if (txt->buffer==0)
		return 0;
	fread(&txt->buffer[1],1,*lSize,pFile);
	fclose(pFile);
	txt->buffer[0]=0; //must begin by 0
	txt->size=(*lSize)+2;
	txt->buffer[txt->size]=0; //buffer must end by 0 so buffer = text + 0
	free(lSize);
	return txt;
}

void Write_File(char *filename,text_buffer* txt){
	FILE *pFile;
	pFile=fopen(filename,"wb");
	if (pFile==0)
		return;
	fwrite(txt->buffer,1,txt->size,pFile);
	fclose(pFile);
}

char Formated_Char(char c)
{
	if (c=='-')
		return c;
	if (c>='A' && c<='Z')
		return c+('a'-'A');
	if (c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='')
		return 'e';
	if (c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='')
		return 'a';
	if (c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='')
		return 'i';
	if (c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='')
		return 'o';
	if (c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='' || c=='')
		return 'u';
	if (c=='' || c=='')
		return 'c';
	if (c=='' || c=='')
		return 'n';
	if (c=='' || c=='' || c=='')
		return 'n';
	if (c>='a' && c<='z')
		return c;
	return 0;
	//"","aaaaaceeeeiiiinooooouuuuyyAAAAACEEEEIIIINOOOOOUUUUY"
}

void Format_Text(text_buffer* txt)
{
//Maj > min, remove accent, remove non auth. char.
	int i;
	for (i=0;i<txt->size;i++)
	{
		txt->buffer[i]=Formated_Char(txt->buffer[i]);
	}
}

void Write_Freq_File(char* filename,freq_buffer *freq,int fq)
{
	char *buff=malloc(max_buffer);
	int i,j=0;
	for (i=0;i<freq->count;i++)
	{
		if (freq->freq[i]>=fq)
			j+=sprintf(&buff[j],"%s;%d;\n",freq->buffer[i],freq->freq[i]);
	}
	text_buffer t;
	t.size=j;
	t.buffer=buff;
	Write_File(filename,&t);
}

void AntiDico(text_buffer *txt,char *filename)
{
	if (txt->size==0 || txt->buffer==0)
		return;
	text_buffer *t2=Open_File(filename);
	if (t2==0 || t2->buffer==0 || t2->size==0)
	{
		printf("%s non trouve ou vide\n",filename);
		return;
	}
	Format_Text(t2);
	Arbre_Dico *tree_dico=Arbre_Dico_Init();
	Arbre_Dico * t;
	int i,j;
	j=0;
	for (i=0;i<t2->size;i++)
	{
		if (i>j)
		{
			if (t2->buffer[i]==0)
			{
				Arbre_Dico_ADD(tree_dico,&t2->buffer[j]);
				j=i+1;
			}
		} else {
			if (t2->buffer[i]==0)
				j=i+1;
			else
				j=i;
		}
	}
	j=0;
	int k;
	for (i=0;i<txt->size;i++)
	{
		if (i>j)
		{
			if (txt->buffer[i]==0)
			{
				t=Arbre_Dico_FOUND(tree_dico,&txt->buffer[j]);
				if (t!=0)
				{
					for (k=j;k<i;k++)
					{
						txt->buffer[k]=0;
					}
				}
				j=i+1;
			}
		} else {
			if (txt->buffer[i]==0)
				j=i+1;
			else
				j=i;
		}
	}
	Arbre_Dico_FREE(tree_dico);
	free(t2->buffer);
	free(t2);
}

void DelFreqWords(text_buffer *txt,freq_buffer *freq, int fq)
{
	int i,j;
	Arbre_Dico *tree=Arbre_Dico_Init();
	Arbre_Dico * t;
	for (i=0;i<freq->count;i++)
	{
		if (!(fq<=freq->freq[i]))
		{
			Arbre_Dico_ADD(tree,freq->buffer[i]);
		}
	}
	j=0;
	int k;
	for (i=0;i<txt->size;i++)
	{
		if (i>j)
		{
			if (txt->buffer[i]==0)
			{
				t=Arbre_Dico_FOUND(tree,&txt->buffer[j]);
				if (t!=0)
				{
					k=j;
					while (txt->buffer[k]!=0)
					{
						txt->buffer[k]=0;
						k++;
					}
				}
				j=i+1;
			}
		} else {
			if (txt->buffer[i]==0)
				j=i+1;
			else
				j=i;
		}
	}
	Arbre_Dico_FREE(tree);
}

point_texte* Text_Pointer(text_buffer *txt,freq_buffer *freq, int fq)
{
	point_texte *pt=malloc(sizeof(point_texte));
	pt->count=0;
	pt->nbgarde=0;
	int i,j;
	Arbre_Dico *tree=Arbre_Dico_Init();
	Arbre_Dico * t;
	//printf("mots gardes: ");
	for (i=0;i<freq->count;i++)
	{
		if (fq<=freq->freq[i])
		{
			Arbre_Dico_ADD(tree,freq->buffer[i]);
			pt->mot[pt->nbgarde+1]=freq->buffer[i];
			pt->freq[pt->nbgarde+1]=freq->freq[i];
			pt->nbgarde+=1;
			// pt->mot[pt->nbgarde]=freq->buffer[i];
			// pt->freq[pt->nbgarde]=freq->freq[i];
			//printf("%s;",mot(i));
		}
	}
	//printf("\n",mot(i));
	//pt->nbgarde+=1;
	j=0;
	int k;
	for (i=0;i<txt->size;i++)
	{
		if (i>j)
		{
			if (txt->buffer[i]==0)
			{
				t=Arbre_Dico_FOUND(tree,&txt->buffer[j]);
				if (t!=0)
				{
					for (k=0;k<pt->nbgarde;k++)
					{
						if (strcmp(&txt->buffer[j],pt->mot[k+1])==0)
						{
							pt->number[pt->count]=k+1;
							break;
						}
					}
				} else {
					pt->number[pt->count]=0;
				}
				pt->count++;
				j=i+1;
			}
		} else {
			if (txt->buffer[i]==0)
				j=i+1;
			else
				j=i;
		}
	}
	Arbre_Dico_FREE(tree);
	return pt;
}

void Write_Text(text_buffer* txt,char* filename)
{
	FILE *f=fopen(filename,"wb");
	int i,j;
	j=0;
	for (i=0;i<txt->size;i++)
	{
		if (i>j)
		{
			if (txt->buffer[i]==0)
			{
				fprintf(f,"%s\n",&txt->buffer[j]);
				j=i+1;
			}
		} else {
			if (txt->buffer[i]==0)
				j=i+1;
			else
				j=i;
		}
	}
	fclose(f);
}



